<?php

namespace App\Service;


use App\Model\SysMenu;
use App\Models\BasicProcedure;
use App\Models\BasicProcess;
use App\Models\Procedure;

/**
 * 工序相关
 * @package App\Models
 */
class ProcedureService extends Service
{

    public function basicProcedureEdit($data){
        list($status,$msg) = $this->basicProcedureRule($data);
        if(!$status) return [$status,$msg];
        if($this->isEmpty($data,'id')) return [false,'ID不存在'];
        $first = BasicProcedure::where('title',$data['title'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];


        $model = new BasicProcedure();
        $model = $model->where('id',$data['id'])->first();
        $model->title = $data['title'];
        $model->parent_id = $data['parent_id'] ;
        $model->save();


        return [true,'保存成功！'];

    }

    public function basicProcedureAdd($data,$user){


//        if($this->isEmpty($data,'title')) return [201,'名称不存在！'];
        list($status,$msg) = $this->basicProcedureRule($data);
        if(!$status) return [$status,$msg];
        $first = BasicProcedure::where('title',$data['title'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new BasicProcedure();

        $model->title = $data['title'];
        $model->parent_id = $data['parent_id'] ;
        $model->save();

        return [true,'保存成功！'];

    }

    public function basicProcedureDel($data){
        if($this->isEmpty($data,'id')) return [false,'ID必须！'];

        BasicProcedure::where('id',$data['id'])->update([
            'del_time',time()
        ]);

        return [true,'删除成功'];
    }

    public function basicProcedureList($data){
        $list = BasicProcedure::where('del_time',0)->select('title','parent_id','crt_time','upd_time')->get()->toArray();
        $return = $this->makeTree(0,$list);
        $return = $this->set_sort_circle($return);


        return [200,$return];
    }

    public function basicProcedureRule($data){
        if($this->isEmpty($data,'title')) return [false,'名称不存在！'];
        if($this->isEmpty($data,'parent_id')) return [false,'父级不存在！'];

        return [true,''];
    }


    public function procedureEdit($data){
        list($status,$msg) = $this->procedureRule($data);
        if(!$status) return [$status,$msg];
        if($this->isEmpty($data,'id')) return [false,'ID不存在'];
        $first = Procedure::where('title',$data['title'])->where('id','<>',$data['id'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];


        $model = new Procedure();
        $model = $model->where('id',$data['id'])->first();
        $model->title = $data['title'];
        $model->p_id = $data['p_id'] ;
        $model->save();


        return [true,'保存成功！'];

    }

    public function procedureAdd($data,$user){


//        if($this->isEmpty($data,'title')) return [201,'名称不存在！'];
        list($status,$msg) = $this->procedureRule($data);
        if(!$status) return [$status,$msg];
        $first = Procedure::where('title',$data['title'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new Procedure();

        $model->title = $data['title'];
        $model->p_id = $data['p_id'] ;
        $model->save();

        return [true,'保存成功！'];

    }

    public function procedureDel($data){
        if($this->isEmpty($data,'id')) return [false,'ID必须！'];

        Procedure::where('id',$data['id'])->update([
            'del_time',time()
        ]);

        return [true,'删除成功'];
    }

    public function procedureList($data){
        $list = Procedure::where('del_time',0)->select('title','p_id','crt_time','upd_time')->get()->toArray();

        $list = $this->limit($list,'',$data);


        return [200,$list];
    }

    public function procedureRule($data){
        if($this->isEmpty($data,'title')) return [false,'名称不存在！'];
        if($this->isEmpty($data,'p_id')) return [false,'分类不存在！'];

        return [true,''];
    }


}
