<?php

namespace App\Service;


use App\Model\SysMenu;
use App\Models\BasicProcess;
use App\Models\Process;

/**
 * 工艺相关
 * @package App\Models
 */
class ProcessService extends Service
{

    public function basicProcessEdit($data){
        list($status,$msg) = $this->basicProcessRule($data);
        if(!$status) return [$status,$msg];
        if($this->isEmpty($data,'id')) return [false,'ID不存在'];
        $first = BasicProcess::where('title',$data['title'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];


        $model = new BasicProcess();
        $model = $model->where('id',$data['id'])->first();
        $model->title = $data['title'];
        $model->parent_id = $data['parent_id'] ;
        $model->save();


        return [true,'保存成功！'];

    }

    public function basicProcessAdd($data,$user){


//        if($this->isEmpty($data,'title')) return [201,'名称不存在！'];
        list($status,$msg) = $this->basicProcessRule($data);
        if(!$status) return [$status,$msg];
        $first = BasicProcess::where('title',$data['title'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new BasicProcess();

        $model->title = $data['title'];
        $model->parent_id = $data['parent_id'] ;
        $model->save();

        return [true,'保存成功！'];

    }

    public function basicProcessDel($data){
        if($this->isEmpty($data,'id')) return [false,'ID必须！'];

        BasicProcess::where('id',$data['id'])->update([
            'del_time',time()
        ]);

        return [true,'删除成功'];
    }

    public function basicProcessList($data){
        $list = BasicProcess::where('del_time',0)->select('title','parent_id','crt_time','upd_time')->get()->toArray();
        $return = $this->makeTree(0,$list);
        $return = $this->set_sort_circle($return);


        return [200,$return];
    }

    public function basicProcessRule($data){
        if($this->isEmpty($data,'title')) return [false,'名称不存在！'];
        if($this->isEmpty($data,'parent_id')) return [false,'父级不存在！'];

        return [true,''];
    }

    public function processEdit($data){
        list($status,$msg) = $this->processRule($data);
        if(!$status) return [$status,$msg];
        if($this->isEmpty($data,'id')) return [false,'ID不存在'];
        $first = Process::where('title',$data['title'])->where('id','<>',$data['id'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];


        $model = new Process();
        $model = $model->where('id',$data['id'])->first();
        $model->title = $data['title'];
        $model->p_id = $data['p_id'] ;
        $model->save();


        return [true,'保存成功！'];

    }

    public function processAdd($data,$user){


//        if($this->isEmpty($data,'title')) return [201,'名称不存在！'];
        list($status,$msg) = $this->processRule($data);
        if(!$status) return [$status,$msg];
        $first = Process::where('title',$data['title'])->where('del_time',0)->first();
        if(!empty($first))return [false,'名称已存在！'];

        $model = new Process();

        $model->title = $data['title'];
        $model->p_id = $data['p_id'] ;
        $model->save();

        return [true,'保存成功！'];

    }

    public function processDel($data){
        if($this->isEmpty($data,'id')) return [false,'ID必须！'];

        Process::where('id',$data['id'])->update([
            'del_time',time()
        ]);

        return [true,'删除成功'];
    }

    public function processList($data){
        $list = Process::where('del_time',0)->select('title','p_id','crt_time','upd_time');
//        $return = $this->makeTree(0,$list);
//        $return = $this->set_sort_circle($return);
        $list = $this->limit($list,'',$list);

        return [200,$list];
    }

    public function processRule($data){
        if($this->isEmpty($data,'title')) return [false,'名称不存在！'];
        if($this->isEmpty($data,'p_id')) return [false,'分类不存在！'];

        return [true,''];
    }


}
